import type { Locale } from '../interface';
/**
 * Used for `useFilledProps` since it already in the React.useMemo
 */
export declare function fillLocale(locale: Locale): {
    fieldDateTimeFormat: string;
    fieldDateFormat: string;
    fieldTimeFormat: string;
    fieldMonthFormat: string;
    fieldYearFormat: string;
    fieldWeekFormat: string;
    fieldQuarterFormat: string;
    yearFormat: string;
    cellYearFormat: string;
    cellQuarterFormat: string;
    cellDateFormat: string;
    locale: string;
    dateFormat?: string;
    dateTimeFormat?: string;
    monthBeforeYear?: boolean;
    monthFormat?: string;
    dayFormat?: string;
    cellMeridiemFormat?: string;
    today: string;
    now: string;
    backToToday: string;
    ok: string;
    timeSelect: string;
    dateSelect: string;
    weekSelect?: string;
    clear: string;
    month: string;
    year: string;
    previousMonth: string;
    nextMonth: string;
    monthSelect: string;
    yearSelect: string;
    decadeSelect: string;
    previousYear: string;
    nextYear: string;
    previousDecade: string;
    nextDecade: string;
    previousCentury: string;
    nextCentury: string;
    shortWeekDays?: string[];
    shortMonths?: string[];
};
/**
 * Fill locale format as start up
 */
export default function useLocale(locale: Locale): {
    fieldDateTimeFormat: string;
    fieldDateFormat: string;
    fieldTimeFormat: string;
    fieldMonthFormat: string;
    fieldYearFormat: string;
    fieldWeekFormat: string;
    fieldQuarterFormat: string;
    yearFormat: string;
    cellYearFormat: string;
    cellQuarterFormat: string;
    cellDateFormat: string;
    locale: string;
    dateFormat?: string;
    dateTimeFormat?: string;
    monthBeforeYear?: boolean;
    monthFormat?: string;
    dayFormat?: string;
    cellMeridiemFormat?: string;
    today: string;
    now: string;
    backToToday: string;
    ok: string;
    timeSelect: string;
    dateSelect: string;
    weekSelect?: string;
    clear: string;
    month: string;
    year: string;
    previousMonth: string;
    nextMonth: string;
    monthSelect: string;
    yearSelect: string;
    decadeSelect: string;
    previousYear: string;
    nextYear: string;
    previousDecade: string;
    nextDecade: string;
    previousCentury: string;
    nextCentury: string;
    shortWeekDays?: string[];
    shortMonths?: string[];
};
