import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _typeof from "@babel/runtime/helpers/esm/typeof";
import { pickProps } from "../utils/miscUtil";
var showTimeKeys = ['format', 'showNow', 'showHour', 'showMinute', 'showSecond', 'showMillisecond', 'use12Hours', 'hourStep', 'minuteStep', 'secondStep', 'millisecondStep', 'hideDisabledOptions', 'defaultValue', 'disabledHours', 'disabledMinutes', 'disabledSeconds', 'disabledMilliseconds', 'disabledTime', 'changeOnScroll'];

/**
 * Get SharedTimeProps from props.
 */
function pickTimeProps(props) {
  var timeProps = pickProps(props, showTimeKeys);
  if (timeProps.format) {
    var format = timeProps.format;
    if (Array.isArray(format)) {
      format = format[0];
    }
    timeProps.format = _typeof(format) === 'object' ? format.format : format;
  }
  return timeProps;
}
export function getTimeConfig() {
  var componentProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var showTime = componentProps.showTime,
    picker = componentProps.picker;
  if (showTime || picker === 'time') {
    var timeConfig = showTime && _typeof(showTime) === 'object' ? showTime : pickTimeProps(componentProps);
    return _objectSpread({
      format: 'HH:mm:ss'
    }, timeConfig);
  }
  return null;
}