import * as React from 'react';
import type { GenerateConfig } from '../../generate';
import type { DisabledDate, InternalMode, PanelMode, RangeTimeProps, SharedPickerProps } from '../../interface';
export interface FooterProps<DateType extends object = any> {
    mode: PanelMode;
    internalMode: InternalMode;
    renderExtraFooter?: SharedPickerProps['renderExtraFooter'];
    showNow: boolean;
    generateConfig: GenerateConfig<DateType>;
    disabledDate: DisabledDate<DateType>;
    showTime?: Omit<RangeTimeProps<DateType>, 'defaultValue'>;
    /** From Footer component used only. Check if can OK button click */
    invalid?: boolean;
    onSubmit: (date?: DateType) => void;
    needConfirm: boolean;
    onOk: VoidFunction;
    onNow: (now: DateType) => void;
}
export default function Footer(props: FooterProps): React.JSX.Element;
